//+------------------------------------------------------------------+
//|                                                 Nailer EA V1.mq4 |
//|                                                   loksterEbKDeak |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "loksterebkdeak"
#property link      "loksterebkdeak@gmail.com"

#define MAGICNUMBER     8675309
#define SELL_FLAG       1
#define BUY_FLAG        2
#define NOTVALID_FLAG   3

extern double Lots = 0.1;
extern int StopLoss = 5;
extern int TakeProfit = 50;
extern int TrailingStop = 0;
extern int Slippage = 3;
extern double SARStep = 0.02;
extern double SARMax = 0.2;
extern string Commnt = "Below values only apply when MoneyManagement is ON";
extern bool MoneyManagement = FALSE;
extern int RiskPercent = 1;
extern double MaxLots = 1.0;


int start()
{
   
   // if preflights dont check bail out
   if (preFlight() == FALSE) return(0);
   
   static int orderbarcount;
   int acc = acceleratorSwitch();
   int awe = awesomeSwitch();
   int sar = sarSwitch();
   int ticket;
   
   // only one order at a time allowed open
   for (int i = 0;i < OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if (OrderMagicNumber() == MAGICNUMBER && OrderSymbol() == Symbol())
      {
         // custom closing routines to go here!!!
         ////////////////////////////////////////
         
         
         // trailing stop if necessary
         if (OrderType() == OP_BUY && TrailingStop > 0)
         {
            if (Bid - OrderOpenPrice() > Point * TrailingStop)
            {
               if (OrderStopLoss() < Bid - Point * TrailingStop)
                  OrderModify(OrderTicket(),OrderOpenPrice(),Bid - Point * TrailingStop,OrderTakeProfit(),0,Green);
            }
         }
         else if (OrderType() == OP_SELL && TrailingStop > 0)
         {
            if ((OrderOpenPrice() - Ask) > (Point * TrailingStop))
            {
               if ((OrderStopLoss() > (Ask + Point * TrailingStop)) || (OrderStopLoss() == 0))
                  OrderModify(OrderTicket(),OrderOpenPrice(),Ask + Point * TrailingStop,OrderTakeProfit(),0,Red);
            }
         }
         
         return(0);
      }
         
   }
   
  
   // all buy conditions have been met
   if (acc == BUY_FLAG && awe == BUY_FLAG && sar == BUY_FLAG && orderbarcount != Bars)
   {
      RefreshRates();
      ticket = OrderSend(Symbol(), OP_BUY, LotsOptimized(), Ask, Slippage, Bid - StopLoss * Point, Bid + TakeProfit * Point, "Nailer Buy", MAGICNUMBER, 0, Blue); 
      if (ticket == -1)
         Print("error:", GetLastError());
      else
         orderbarcount = Bars; // so we dont re-enter another trade on this bar
   }
   // all sell condtions have been met
   else if (acc == SELL_FLAG && awe == SELL_FLAG && sar == SELL_FLAG)
   {
      RefreshRates();
      ticket = OrderSend(Symbol(), OP_SELL, LotsOptimized(), Bid, Slippage, Ask + StopLoss * Point, Ask - TakeProfit * Point, "Nailer Sell", MAGICNUMBER, 0, Red); 
      if (ticket == -1)
         Print("error:", GetLastError());
      else
         orderbarcount = Bars; // so we dont re-enter another trade on the trade
   }
   
   return(0);
}

double LotsOptimized()
{
   if (MoneyManagement == FALSE)
      return(Lots);
      
   // TODO Add better money management
   double tmplots = AccountFreeMargin() * RiskPercent / 100 / StopLoss / 10;
   Print(DoubleToStr(tmplots,2));
   if (tmplots > MaxLots)
      return(MaxLots);
   else
      return(tmplots);
}


bool preFlight()
{
   // if any pre-run checks are needed put them here.
   if(AccountFreeMargin()<(1000*Lots))
   {
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(FALSE);  
   }
   if(Bars < 100)
      return(FALSE);
      
   return(TRUE);  
}

int acceleratorSwitch()
{
   double prevacc = iAC(NULL,0,1);
   double curracc = iAC(NULL,0,0);
   
   // sell flag
   if (prevacc > curracc)
      return(SELL_FLAG);
   // buy flag
   else if (prevacc < curracc)
      return(BUY_FLAG);
   // notvalid flag
   else
      return(NOTVALID_FLAG);
}

int awesomeSwitch()
{
   double prevawe = iAO(NULL,0,1);
   double currawe = iAO(NULL,0,0);
   
   // sell flag   
   if (prevawe > currawe)
      return(SELL_FLAG);
   // buy flag
   else if (prevawe < currawe)
      return(BUY_FLAG);
   // notvalid flag
   else
      return(NOTVALID_FLAG);
}

int sarSwitch()
{
   double prevsar = iSAR(NULL,0,SARStep,SARMax,1);
   double currsar = iSAR(NULL,0,SARStep,SARMax,0);
   
   // sell flag
   if (prevsar < Close[1] && currsar > Open[0])
      return(SELL_FLAG);
   // buy flag
   else if (prevsar > Open[1] && currsar < Close[0])
      return(BUY_FLAG);
   // not valid flag
   else
      return(NOTVALID_FLAG);  
}

